<?php
/**
* Newsletter Tab Class for handling the CB tab api
* @author Mikko Rönkkö
* @copyright (C) Mikko Rönkkö
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$_PLUGINS->registerFunction( 'onUserActive', 'userActivated','getAcajoomTab' );
$_PLUGINS->registerFunction( 'onAfterDeleteUser', 'userDeleted','getAcajoomTab' );

 // include required files

/*
This is adopted from acajoom, you may want to change it
*/
 global $mainframe;
 
 require_once($mainframe->getPath('front_html'));

 require_once($mosConfig_absolute_path . '/administrator/components/com_acajoom/classes/class.acajoom.php');
 require_once($mosConfig_absolute_path . '/administrator/components/com_acajoom/classes/class.frontend.php');

 require_once($mosConfig_absolute_path . '/administrator/components/com_acajoom/admin.acajoom.html.php' );
 require_once($mosConfig_absolute_path . '/administrator/components/com_acajoom/subscribers.acajoom.html.php' );
 require_once($mosConfig_absolute_path . '/administrator/components/com_acajoom/lists.acajoom.html.php' );
 require_once($mosConfig_absolute_path . '/administrator/components/com_acajoom/mailings.acajoom.html.php' );

 require_once($mosConfig_absolute_path . '/components/com_acajoom/acajoom.html.php' );

	$acajoomConfig = xonfig::loadConfig();

 global $Itemid;

 	 // get parameters
	$subscriberId = mosGetParam($_REQUEST, 'subscriber', 0);  // when link from outside
	$listId = mosGetParam($_REQUEST, 'listid', 0);
 	$mailingId = mosGetParam($_REQUEST, 'mailingid', 0);
 	$lisType = mosGetParam($_REQUEST, 'listype', 0);
 	$action = mosGetParam($_REQUEST, 'act', '');
	$task = trim( mosGetParam( $_REQUEST, 'task', null ) );
	$message = mosGetParam($_REQUEST, 'message', '');
	$name = trim( mosGetParam( $_REQUEST, 'name', null ) );
	$email = trim( mosGetParam( $_REQUEST, 'email', null ) );
	$cle = trim( mosGetParam( $_REQUEST, 'cle', null ) );
	$redirectlink = trim( mosGetParam( $_REQUEST, 'redirectlink', '' ) );

	$userId = $my->id;  // when logged in

 // get user's id if not defined
 if ( $subscriberId>0 && !empty($cle) && $userId<1) {
		if (subscribers::checkValidKey($subscriberId, $cle)) {
			$userId = $subscriberId;
		} else {
			 echo acajoom::printM ('red' , _NOT_AUTH);
		}// end if
 } // end if

 if ($userId>0 && empty($cle) && $subscriberId<1) $subscriberId = subscribers::getSubscriberIdFromUserId($userId);
$showPanel = false;

/*
Code adopted from acajoom ends
*/

class getAcajoomTab extends cbTabHandler {
	/**
	* Constructor
	*/	
	function getAcajoomTab() {
		$this->cbTabHandler();
	}

	/**
	This function would display the tab when profile is viewed. No need to implement.
	*/

	// function getDisplayTab($tab,$user,$ui) {
	// }
	
	
	
	/**
	* Generates the HTML to display the user edit tab
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function getEditTab( $tab, $user, $ui) {

		global $my, $mosConfig_absolute_path, $_POST;
		if(intval($my->id) < 1){
			mosNotAuth();
			return false;
		}
		
		/*
		Change this to call a function that produces the html to show in tabs.
		
		This html will be displayed inside form element with submit button, so only inputs are needed.		
		*/
		return frontEnd::subscriptions($subscriberId, 0, 'save'); 
	}
	
	/**
	* Saves the user edit tab postdata into the tab's permanent storage
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @param array _POST data for saving edited tab content as generated with getEditTab
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function saveEditTab($tab, &$user, $ui, $postdata) {
		global $my, $mosConfig_absolute_path, $_POST;
		if(intval($my->id) < 1) {
			mosNotAuth();
			return;
		}
		/*
		Change this to call a function that saves the settings.
		
		This html will be displayed inside form element with submit button, so only inputs are needed.		
		
		This is called when the edit tab is submitted
		*/
		if(!subscribers::updateOneSubscriber())
			$this->_setErrorMSG(_ACA_ERROR);		
		
	}
	/**
	* Generates the HTML to display the registration tab/area
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed (here null)
	* @param int 1 for front-end, 2 for back-end
	* @return mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function getDisplayRegistration($tab, $user, $ui) {
		global $my, $mosConfig_absolute_path, $_POST;;
		
		/*
			If you wish to show something on the registration form, code it here. 
			I think that newsletter plugins do not commonly implement this.
		*/
			return null;
	}
	/**
	* Saves the registration tab/area postdata into the tab's permanent storage
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed (here null)
	* @param int 1 for front-end, 2 for back-end
	* @param array _POST data for saving edited tab content as generated with getEditTab
	* @return boolean : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function saveRegistrationTab($tab, &$user, $ui, $postdata) {
		global $ueConfig, $mosConfig_absolute_path;
		/*
		Change this to call a function that saves the registration.
		I think that newsletter plugins do not commonly implement this.
		This is called when the registration tab is submitted
		*/

			return true;
	}
	/**
	* Called once ConfirmationCode verified and user found and approved by moderator if needed
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function userActivated($user, $success) {
		global $ueConfig, $mosConfig_absolute_path, $mosConfig_uniquemail;

			/*
			Here you propably would like to call some code that autosubscribes the user.
			User email and name can be fetched by calling $user->email and $user->name
			*/
			return true;
	}
	/**
	* Called when a user is deleted from backend (prepare future unregistration)
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function userDeleted($user, $success) {
			/*
			Here you propably would like to call some code that unsubscribes the user.
			User email and name can be fetched by calling $user->email and $user->name
			*/
	}
	
} // end class getAcajoomTab
?>
